<script setup lang="ts">
    import SInterventionCreation from '@/interventionServiceOffer/components/intervention/SInterventionCreation.vue'
    import { ComputedRef, Ref, computed, ref } from 'vue'
    import { Intervention } from '@/interventionServiceOffer/entities/intervention/Intervention'
    import { ActiviteDiagnostique } from '@/interventionServiceOffer/entities/activite/ActiviteDiagnostique'
    import { ActiviteDiagnostiqueApi } from '@/interventionServiceOffer/entities/activite/ActiviteDiagnostiqueApi'
    import { activiteDiagnostiqueMapper } from '@/interventionServiceOffer/entities/activite/ActiviteDiagnostiqueMapper'
    import {
        isDefined,
        isNull,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { IncompleteEntity } from '@/shared/errors/IncompleteEntity'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import { MissingFormError } from '@/interventionServiceOffer/errors/MissingFormError'
    import { SilabError } from '@/shared/errors/SilabError'
    import SDemandeInterventionCreation from '../demandeIntervention/SDemandeInterventionCreation.vue'
    import { DemandeIntervention } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeIntervention'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const msal = useMsal()
    const userStore = useUserStore(msal)

    const activiteDiagnostique = defineModel<Partial<ActiviteDiagnostique>>({
        required: true,
    })
    /**
     * @var intervention l'intervention permet de rattacher à son équipement une OT ou DI généré par l'opération si elle n'en possède pas elle même
     */
    interface Props {
        intervention: Intervention
        isLocked?: boolean
    }
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const props = withDefaults(defineProps<Props>(), {
        isLocked: false,
    })

    const activiteDiagnostiqueApi = new ActiviteDiagnostiqueApi(msal)

    const interventionCreationRef = ref<InstanceType<
        typeof SInterventionCreation
    > | null>(null)

    const demandeInterventionCreationRef = ref<InstanceType<
        typeof SDemandeInterventionCreation
    > | null>(null)
    const opérationComplétée: ComputedRef<boolean> = computed(() => {
        const formulaireDemandeComplété =
            isNull(demandeInterventionCreationRef.value) ||
            demandeInterventionCreationRef.value?.formFieldsAreValid === true
        const formulaireInterventionComplété =
            isNull(interventionCreationRef.value) ||
            interventionCreationRef.value?.formFieldsAreValid === true
        return (
            isDefined(activiteDiagnostique.value.evaluation) &&
            formulaireDemandeComplété &&
            formulaireInterventionComplété
        )
    })
    const equipementDeRattachementPourGénération =
        activiteDiagnostique.value.equipementCible ??
        props.intervention.relatedEquipement
    const coordonnéesDeRattachementPourGénération =
        activiteDiagnostique.value.equipementCible?.coordinates ??
        props.intervention.relatedEquipement?.coordinates

    const interventionGénérée: Ref<Partial<Intervention>> = ref({
        coordinates: coordonnéesDeRattachementPourGénération,
    })

    const demandeInterventionGénérée: Ref<Partial<DemandeIntervention>> = ref({
        coordonnees: coordonnéesDeRattachementPourGénération,
    })

    async function validerActivite(): Promise<ActiviteDiagnostique> {
        if (
            !userStore.currentUserHasRoleForServiceOffer(
                'INTERVENTION_MODIFIER_ACTIVITE',
                serviceOfferId.value
            )
        ) {
            throw new SilabError(
                `Vous n'avez pas les droits suffisants pour saisir des diagnostiques`
            )
        }
        if (isUndefined(activiteDiagnostique.value.id)) {
            throw new IncompleteEntity("id de l'opération manquants")
        }
        switch (activiteDiagnostique.value.evaluation) {
            case 'non conforme':
                if (isNull(interventionCreationRef.value)) {
                    throw new MissingFormError(
                        "Le formulaire d'intervention est null."
                    )
                }
                try {
                    activiteDiagnostique.value.interventionIdGeneree = (
                        await interventionCreationRef.value.créerIntervention()
                    ).id
                    break
                } catch (error) {
                    throw new SilabError(
                        `Erreur lors de la création de l'intervention`,
                        error
                    )
                }
            case 'reserve':
                if (isNull(demandeInterventionCreationRef.value)) {
                    throw new MissingFormError(
                        "Le formulaire de demande d'intervention est null."
                    )
                }
                try {
                    activiteDiagnostique.value.demandeInterventionIdGeneree = (
                        await demandeInterventionCreationRef.value.créerDemandeIntervention()
                    ).id
                    break
                } catch (error) {
                    throw new SilabError(
                        `Erreur lors de la création de la demande d'intervention`,
                        error
                    )
                }
        }
        activiteDiagnostique.value.dateDeDebut = new Date()
        const activiteDiagnostiqueMiseAJour =
            await activiteDiagnostiqueApi.update(
                serviceOfferId.value,
                activiteDiagnostique.value.id,
                activiteDiagnostiqueMapper.toEditDto(activiteDiagnostique.value)
            )
        return activiteDiagnostiqueMiseAJour
    }
    const isObligatoire = activiteDiagnostique.value.isObligatoire
    defineExpose({ validerActivite, opérationComplétée, isObligatoire })
</script>

<template>
    <div>
        <div class="d-flex flex-column-reverse flex-sm-row position-relative">
            <div class="d-flex align-center">
                <v-btn-toggle
                    v-model="activiteDiagnostique.evaluation"
                    :tile="true"
                    variant="elevated"
                    divided
                    border
                    class="rounded-pill me-3"
                    :class="{ 'w-100': $vuetify.display.xs }"
                    style="height: 55px"
                >
                    <v-btn
                        value="conforme"
                        :rounded="false"
                        :readonly="isLocked"
                        width="auto"
                        :color="isLocked ? 'grey' : 'success'"
                        class="flex-shrink-1 px-4 w-100"
                        :class="{
                            'text-success':
                                activiteDiagnostique.evaluation !== 'conforme',
                        }"
                        data-cy="activite-conforme"
                    >
                        <div
                            class="d-flex flex-column align-center"
                            :class="{
                                'text-grey':
                                    isLocked &&
                                    activiteDiagnostique.evaluation !==
                                        'conforme',
                            }"
                        >
                            <v-icon size="24">mdi-check-bold</v-icon>
                            <span class="text-caption">ok</span>
                        </div>
                    </v-btn>
                    <v-btn
                        value="reserve"
                        :color="isLocked ? 'grey' : 'warning'"
                        icon="mdi-help"
                        :readonly="isLocked"
                        :rounded="false"
                        width="auto"
                        class="flex-shrink-1 px-4 w-100"
                        :class="{
                            'text-warning':
                                activiteDiagnostique.evaluation !== 'reserve',
                        }"
                        data-cy="activite-reserve"
                    >
                        <div
                            class="d-flex flex-column align-center"
                            :class="{
                                'text-grey':
                                    isLocked &&
                                    activiteDiagnostique.evaluation !==
                                        'reserve',
                            }"
                        >
                            <v-icon size="24">mdi-help</v-icon>
                            <span class="text-caption">réserve</span>
                        </div>
                    </v-btn>

                    <v-btn
                        value="non conforme"
                        :color="isLocked ? 'grey' : 'error'"
                        width="auto"
                        :readonly="isLocked"
                        :rounded="false"
                        class="flex-shrink-1 px-4 w-100"
                        :class="{
                            'text-error':
                                activiteDiagnostique.evaluation !==
                                'non conforme',
                        }"
                        data-cy="activite-non-conforme"
                    >
                        <div
                            class="d-flex flex-column align-center"
                            :class="{
                                'text-grey':
                                    isLocked &&
                                    activiteDiagnostique.evaluation !==
                                        'non conforme',
                            }"
                        >
                            <v-icon size="24">mdi-exclamation-thick</v-icon>
                            <span class="text-caption">problème</span>
                        </div>
                    </v-btn>
                </v-btn-toggle>
            </div>
            <div class="flex-grow-1 d-flex flex-column">
                <div class="d-flex">
                    <div class="flex-grow-1">
                        <p
                            class="text-h6"
                            :class="{ 'text-grey-darken-1': isLocked }"
                            style="line-height: 1.5rem"
                            data-cy="title"
                        >
                            {{
                                activiteDiagnostique.getItemTitle
                                    ? activiteDiagnostique.getItemTitle()
                                    : ''
                            }}
                        </p>

                        <span v-if="activiteDiagnostique.getItemDescription">
                            <p
                                class="text-subtitle-2"
                                :class="{
                                    'text-grey-lighten-1': isLocked,
                                    'text-grey-darken-1': !isLocked,
                                }"
                                style="line-height: 1.5rem"
                                data-cy="subtitle"
                            >
                                {{ activiteDiagnostique.getItemDescription() }}
                            </p>
                        </span>
                        <router-link
                            v-if="
                                isLocked &&
                                activiteDiagnostique.evaluation === 'reserve' &&
                                isDefined(
                                    activiteDiagnostique.demandeInterventionIdGeneree
                                )
                            "
                            target="_blank"
                            class="text-subtitle-2"
                            style="line-height: 1.5rem"
                            data-cy="subtitle"
                            :to="{
                                name: 'intervention-service-offer/index',
                                params: {
                                    serviceOfferId,
                                },
                                query: {
                                    'selected-item': `demandes-${
                                        activiteDiagnostique.demandeInterventionIdGeneree
                                    }`,
                                },
                            }"
                        >
                            <v-icon>mdi-comment-question-outline</v-icon>
                            Demande d'intervention générée
                        </router-link>
                        <router-link
                            v-if="
                                isLocked &&
                                activiteDiagnostique.evaluation ===
                                    'non conforme' &&
                                isDefined(
                                    activiteDiagnostique.interventionIdGeneree
                                )
                            "
                            target="_blank"
                            class="text-subtitle-2"
                            style="line-height: 1.5rem"
                            data-cy="subtitle"
                            :to="{
                                name: 'intervention-service-offer/index',
                                params: {
                                    serviceOfferId,
                                },
                                query: {
                                    'selected-item': `interventions-${
                                        activiteDiagnostique.interventionIdGeneree
                                    }`,
                                },
                            }"
                        >
                            <v-icon>mdi-traffic-cone</v-icon>
                            Intervention générée
                        </router-link>
                    </div>
                    <v-icon
                        v-if="activiteDiagnostique.isObligatoire"
                        style="right: 0"
                        size="small"
                        >mdi-asterisk</v-icon
                    >
                </div>
                <div
                    v-if="isLocked"
                    class="text-end pa-0 text-subtitle-2 text-grey-darken-1"
                >
                    {{
                        activiteDiagnostique.getItemTemporalData
                            ? activiteDiagnostique.getItemTemporalData()
                            : ''
                    }}
                </div>
            </div>
        </div>
        <div v-if="!isLocked">
            <v-card
                v-if="activiteDiagnostique.evaluation === 'non conforme'"
                title="Intervention générée"
                class="mx-1 my-3 w-auto"
            >
                <v-divider></v-divider>
                <v-card-item>
                    <s-intervention-creation
                        ref="interventionCreationRef"
                        :intervention-originale="interventionGénérée"
                        class="px-3 pt-2"
                        :available-equipements="
                            equipementDeRattachementPourGénération
                                ? [equipementDeRattachementPourGénération]
                                : []
                        "
                        :is-loading-available-equipements="false"
                        :hidden-fields="{
                            imagesApres: true,
                            relatedEquipement: true,
                            coordinates: true,
                            actionType: true,
                            priority: true,
                            dateDeDebut: true,
                            dateDeFin: true,
                        }"
                        data-cy="intervention-formulaire"
                    >
                    </s-intervention-creation>
                </v-card-item>
            </v-card>
            <v-card
                v-if="activiteDiagnostique.evaluation === 'reserve'"
                title="Demande d'intervention générée"
                class="mx-1 my-3 w-auto"
            >
                <v-divider></v-divider>
                <v-card-item>
                    <s-demande-intervention-creation
                        ref="demandeInterventionCreationRef"
                        class="px-3 pt-2"
                        :demande-intervention="demandeInterventionGénérée"
                        :available-equipements="
                            equipementDeRattachementPourGénération
                                ? [equipementDeRattachementPourGénération]
                                : []
                        "
                        :is-loading-available-equipements="false"
                        :hidden-fields="{
                            relatedEquipement: true,
                            coordonnees: true,
                            dateDeDebutSouhaitee: true,
                            dateDeFinSouhaitee: true,
                        }"
                        data-cy="demande-intervention-formulaire"
                    />
                </v-card-item>
            </v-card>
        </div>
    </div>
</template>
